import { CloudFunction } from 'firebase-functions';
import { QueryDocumentSnapshot } from 'firebase-functions/lib/providers/firestore';
import { Config, Rule } from '../common';
export interface DeleteReferencesRule extends Rule {
    source: {
        collection: string;
    };
    targets: {
        collection: string;
        foreignKey: string;
        isCollectionGroup?: boolean;
    }[];
    hooks?: {
        pre?: Function;
    };
}
export declare function isDeleteReferencesRule(arg: Rule): arg is DeleteReferencesRule;
export declare type DeleteReferencesFunction = CloudFunction<QueryDocumentSnapshot>;
export declare function integrifyDeleteReferences(rule: DeleteReferencesRule, config: Config): DeleteReferencesFunction;
