import { Change, CloudFunction } from 'firebase-functions';
import { DocumentSnapshot } from 'firebase-functions/lib/providers/firestore';
import { Config, Rule } from '../common';
export interface ReplicateAttributesRule extends Rule {
    source: {
        collection: string;
    };
    targets: {
        collection: string;
        foreignKey: string;
        attributeMapping: {
            [sourceAttribute: string]: string;
        };
        isCollectionGroup?: boolean;
    }[];
    hooks?: {
        pre?: Function;
    };
}
export declare function isReplicateAttributesRule(arg: Rule): arg is ReplicateAttributesRule;
export declare type ReplicateAttributesFunction = CloudFunction<Change<DocumentSnapshot>>;
export declare function integrifyReplicateAttributes(rule: ReplicateAttributesRule, config: Config): ReplicateAttributesFunction;
